;---------------------------------------------------------
; IDE-HARDDISK  Recording V0.10
; Contact E-mail: Josef.Soucek@ct.cz
;---------------------------------------------------------

setnam        = $ffbd
setlfs        = $ffba
chkin         = $ffc6
chkout        = $ffc9
open          = $ffc0
chrin         = $ffcf
close         = $ffc3
clall         = $ffe7

hddread       = $def4
hddwrite      = $def1

service_port  = $de40

;NULOVA STRANKA & REGISTERS

POM1     = $4E
POM2     = $4F

;BUFFERS

BUFR     = $FE ;$2000-$2200  READ
BUFW     = $FF ;$2000-$2200  WRITE
                          
Play_speed     = $b0
Record_speed   = $b0

;---------------------------------------
         *= $0830

         JMP RECORD
         JMP PLAYER

;---------------------------------------
;WAIT     LDX #$13
;CLOCK1   NOP
;         NOP
;         NOP
;         NOP
;         DEX
;         BNE CLOCK1
;         RTS
;----------------------------------------------------------
;IDE-Harddisk Player V0.00      1995/96
;----------------------------------------------------------
AFA      = $FA
AFB      = $FB
AFC      = $FC
AFD      = $FD
AD418    = $D418
PFA      = $FA
PFB      = $FB

HORNI    = $B0     ;SAMPL POMOCNA PAMET

;---------------------------------------
PLAYER   LDA #0
         STA $D020
         LDA #6
         STA $D021
;------------------
              ldy #0
get_char_loop = *
              jsr chrin
              sta smp_name,y
              iny
              cmp #$0d
              bne get_char_loop
              
              dey
              tya
              sta service_port
              ldx #<smp_name
              ldy #>smp_name
              jsr setnam
              
              lda #1
              ldx $ba
              ldy #0
              jsr setlfs
              
              jsr open
              bcc open_ok
              
              lda #1
              jsr close
              lda #$ff
              sta service_port
              rts
                         
open_ok       = *
              ldx #1
              jsr chkin
              
              
;         LDA #147     ;CLR SCREEN
;         JSR $FFD2

         SEI

;         JSR SPRITE
         JSR HUDBA
         JSR IRQINIT
         
;         LDA #%00001011   ;VYPNOUT obrazovku
;         STA 53248+17

         CLI

         LDA #$00
         STA INFO    ;INFO ZNAMENA:
         STA SWAP
;--------------------------------------
;INFO 0=stop 2=play
;SWAP 0=NIC 1=PRVNI 2=DRUHY
;--------------------------------------

         LDA #Play_speed    ;SPEED
         STA RYCHLOST+1
         JSR NMIINIT        ;INIT NMI-RYCHLOS

         JMP LOAD
;--------------------------------------
;------------------- NMI PLAY VEKTORY -
;POCATEK V $FA,$FB, KONEC V $FD,$FC

PLAY     PHA
         TYA
         PHA

         LDY #0        ;*
         LDA (PFA),Y
         STA HORNI
         AND #$F0
         LSR A
         LSR A
         LSR A
         LSR A
         STA AD418    ;++++++++++++

         LDA #<PLAY1
         STA $0318
         LDA #>PLAY1
         STA $0319

         PLA
         TAY
         LDA $DD0D
         PLA
         cli
         RTI
;------------------
PLAY1    PHA

         LDA HORNI
         AND #$0F
         STA AD418    ;++++++++++

         LDA #<PLAY
         STA $0318
         LDA #>PLAY
         STA $0319

         INC AFA
         BNE KIKK
         INC AFB

KIKK     LDA AFB
         CMP AFC
         BNE DALE

         LDA AFA
         CMP AFD
         BNE DALE

         LDA #<NICK
         STA $0318
         LDA #>NICK
         STA $0319

DALE     LDA $DD0D
         PLA
         cli
         RTI
;------------------ NMI - nulova faze
NICK     PHA
         LDA INFO
         CMP #2
         BNE NEMELEM

         LDA #$00    ;START LOW
         STA $FA
         LDA #$10    ;START HIGH
         STA $FB
         LDA #$00    ;CIL LOW
         STA $FD
         LDA #$30    ;CIL HIGH
         STA $FC

         LDA #<PLAY
         STA $0318
         LDA #>PLAY
         STA $0319

NEMELEM  LDA $DD0D
         PLA
         cli
         RTI

;---------------------- NMI INIT -------
NMIINIT  = *
RYCHLOST LDA #$A0       ;NMI
         STA $DD04
         LDA #0
         STA $DD05
         LDA #0
         STA $DD06
         STA $DD07
         LDA #$11
         STA $DD0E
         LDA #$51
         STA $DD0F
         LDA #$82
         STA $DD0D
         LDA #0
         STA $DC0E
         RTS
;---------------------------------------
IRQINIT  LDA #<VEKT    ;IRQ
         STA $0314
         LDA #>VEKT
         STA $0315

         LDA #<NICK    ;NMI
         STA $0318
         LDA #>NICK
         STA $0319

         LDA #90        ;IRQ
         STA $D012
         LDA #$1B
         STA $D011
         LDA #$01
         STA $D01A
         LDA #0
         STA $DC0D
         RTS
;---------------------- SPRITE -------
;SPRITE   LDX #63
;         LDA #$00
;IC088    STA $0340,X
;         DEX
;         BNE IC088
;         LDA #%00111100
;         LDX #1
;CARKA    STA $0340,X
;         INX
;         INX
;         INX
;         CPX #$3E
;         BCC CARKA
;
;         LDA #13
;         STA $07F8
;         LDA #7
;         STA $D027    ;BARVA
;         LDA #$01
;         STA $D015
;         STA $D017
;         LDA #0
;         STA $D01B
;         STA $D01D
;         STA $D010
;         RTS
;----------------------- HUDBA  -------
HUDBA    LDX #$18
         LDA #$00
IC0B9    STA $D400,X
         DEX
         BNE IC0B9

         LDA #$FF
         STA $D402   ;LO BYTE KMITOCTU
         STA $D403   ;HI
         LDA #0
         STA $D405   ;ATACK/DECAY
         LDA #$F0
         STA $D606   ;SUSTAIN/RELASE
         LDA #$41
         STA $D404   ;PRAVOUHLEJ

         RTS
;------------------------- I R Q -------
VEKT          = *
         INC $D019
         INC $D021

         LDA INFO
         CMP #2
         bne NEPLAY

         LDA PFB    ;AKTUALIZUJE
         LSR A      ;PROMENOU SWAP
         LSR A      ;PODLE TOHO
         LSR A      ;KTERY BUFFER
         LSR A      ;SE HRAJE
         STA SWAP
         STA service_port

NEPLAY        = *
              LDA $DC01       ;TEST stop
              CMP #%01111111
              BNE JEDE
              
              lda #1
              jsr close
              jsr clall

              JMP 64738       ;RESET

JEDE     DEC $D021
         LDA $DC0D
         PLA
         tay
         PLA
         tax
         PLA
         RTI
;---------------------------------------
INFO     BRK
SWAP     BRK
;---------------------------------------
;PREV     .BYTE 48,49,50,51,52
;         .BYTE 53,54,55,56,57
;         .BYTE 1,2,3,4,5
;         .BYTE 6
;---------------------------------------
LOAD          = *
                            ; START $1000 - $3000
              lda #$00
              sta $b1
              lda #$10
              sta $b2

              lda #$b1
              ldx #$00
              ldy #$20
              JSR hddread
              
              LDA #2       ; !!!!!!!!!!!!!!!
              STA INFO     ; SPUST      !!!!
              
;-------------------------------------- HLAVNI SMYCKA
Play_Loop     = *
              inc $d020
                           ;-----------------
WA            LDA SWAP     ;CEKA NA PREHR.
              CMP #2       ;DRUHEHO BUFFERU
              BNE WA       ;-----------------
              dec $d020
                           ; START $1000 - $2000
              lda #$00
              sta $b1
              lda #$10
              sta $b2

              lda #$b1
              ldx #$00
              ldy #$10
              JSR hddread           
              inc $d020
                           ;-----------------
WA1           LDA SWAP     ;CEKA NA PREHR.
              CMP #1       ;PRVNIHO BUFFERU
              BNE WA1      ;-----------------
              dec $d020
                           ; START $2000 - $3000
              lda #$00
              sta $b1
              lda #$20
              sta $b2

              lda #$b1
              ldx #$00
              ldy #$10
              JSR hddread

              JMP Play_Loop
;--------------------------------------
;END      LDA #0       ; !!!!!!!!!!!!!!!
;         STA INFO
;         JMP END

;----------------------------------------------------------
;IDE-Harddisk Recorder V0.00    1995/96
;----------------------------------------------------------
RECORD        = *
              LDA #0
              STA $D020
              LDA #6
              STA $D021
;------------------
              ldy #0
get_char_write = *
              jsr chrin
              sta smp_name,y
              iny
              cmp #$0d
              bne get_char_write
              
              dey
              tya
              sta service_port
              ldx #<smp_name
              ldy #>smp_name
              jsr setnam
              
              lda #1
              ldx $ba
              ldy #1
              jsr setlfs
              
              jsr open
              bcc open_ok_wr
              
              lda #1
              jsr close
              lda #$ff
              sta service_port
              rts
                         
open_ok_wr    = *
              ldx #1
              jsr chkout

              SEI

;              JSR SPRITE
              JSR HUDBA
              JSR IRQINIT1
              CLI

;              LDA #%00001011   ;VYPNOUT obrazovku
;              STA 53248+17

              LDA #$00
              STA INFO    ;INFO ZNAMENA:
              STA SWAP
;---------------------------------------
;INFO 0=stop 2=rec
;SWAP 0=NIC 1=PRVNI 2=DRUHY
;---------------------------------------
              LDA #Record_speed     ;SPEED
              STA RYCHLOST+1
              JSR NMIINIT  ;INIT NMI-RYCHLOS
 
              JMP SAVE
;---------------------------------------
REC           PHA
              LDA $DD01
              STA $D418

              sta service_port
              
;              STA $D020
;              ASL A
;              ORA #%10100000
;              STA $D000
;              LDA $D012
;              STA $D001

              LDA $DC01
              CMP #$FF   ;TEST KAVESY
              BEQ NESPAC

              LDA #<NICK1
              STA $0318
              LDA #>NICK1
              STA $0319

              LDA #2
              STA INFO

              LDA #%00001011   ;VYPNOUT SCREEN
              STA 53248+17

NESPAC        LDA $DD0D
              PLA
              cli
              RTI
;---------------------------------------
REC1          PHA
              TYA
              PHA

              LDY $DD01
              STY $D418    ;++++++++++

              LDA F08BF,Y
              STA HORNI

              LDA #<REC2
              STA $0318
              LDA #>REC2
              STA $0319

              PLA
              TAY
              LDA $DD0D
              PLA
              cli
              RTI
;-----------
REC2          PHA
              TYA
              PHA

              LDY $DD01
              STY $D418    ;++++++++++

              LDA HORNI
              AND F08CF,Y

              LDY #0        ;*
              STA (PFA),Y

              LDA #<REC1
              STA $0318
              LDA #>REC1
              STA $0319

              INC AFA
              BNE DALE1
              INC AFB

              LDA AFB
              CMP AFC
              BNE DALE1

              LDA #<NICK1
              STA $0318
              LDA #>NICK1
              STA $0319

;              INC $D020
;              INC $D020

DALE1         PLA
              TAY
              LDA $DD0D
              PLA
              cli
              RTI

NICK1         PHA
;              LDA INFO
;              CMP #2
;              BNE NEME1

              LDA #$00    ;START LOW
              STA $FA
              LDA #$10    ;START HIGH
              STA $FB
              LDA #$00    ;CIL LOW
              STA $FD
              LDA #$30    ;CIL HIGH
              STA $FC

              LDA #<REC1
              STA $0318
              LDA #>REC1
              STA $0319

NEME1         LDA $DD0D
              PLA
              cli
              RTI

;------------------- DATA K REC -------
F08BF         .BYTE $0F
              .BYTE $1F,$2F,$3F,$4F
              .BYTE $5F,$6F,$7F,$8F
              .BYTE $9F,$AF,$BF,$CF
              .BYTE $DF,$EF,$FF
F08CF         .BYTE $F0,$F1,$F2,$F3
              .BYTE $F4,$F5,$F6,$F7
              .BYTE $F8,$F9,$FA,$FB
              .BYTE $FC,$FD,$FE,$FF
;--------------------------------------
IRQINIT1 LDA #<VEKT    ;IRQ
         STA $0314
         LDA #>VEKT
         STA $0315

         LDA #<REC     ;NMI
         STA $0318
         LDA #>REC
         STA $0319

         LDA #90        ;IRQ
         STA $D012
         LDA #$1B
         STA $D011
         LDA #$01
         STA $D01A
         LDA #0
         STA $DC0D
         RTS
;---------------------------------------
SAVE          = *
;              JMP RECC     ; @ K TEST UCELUM

rec_main_loop = *
              inc $d020
                           ;------------------
GAA           LDA SWAP     ;CEKA NA NAHR.
              CMP #2       ;DRUHEHO BUFFERU
              BNE GAA      ;------------------
              dec $d020
                           ; START $1000
              lda #$00
              sta $b1
              lda #$10
              sta $b2

              lda #$b1
              ldx #$00
              ldy #$10
              JSR hddwrite

              inc $d020
                           ;------------------
GAA1          LDA SWAP     ;CEKA NA NAHR.
              CMP #1       ;PRVNIHO BUFFERU
              BNE GAA1     ;------------------
              dec $d020
                           ; START $2000
              lda #$00
              sta $b1
              lda #$20
              sta $b2

              lda #$b1
              ldx #$00
              ldy #$10
              JSR hddwrite

              JMP rec_main_loop
;---------------------------------------
smp_name      .text "1234567890123456"